#include<inttypes.h>

/**************	optimized division 32 bit / 7 bit with remainder ********/

// GCC 4.2.2: 36 Byte
// GCC 4.3.0: 92 Byte (255%)


uint32_t udivr32_7( uint32_t a, uint8_t b, uint8_t *r )
{
  uint8_t i, t;

  for(  t = 0, i = 32; i ; i-- ){
    t += t;
    if( a & 0x80000000UL )
      t++;
    a += a;
    if( t >= b ){
      t -= b;
      a |= 1;
    }
  }
  *r = t;
  return a;
}


int main( void )
{
  for(;;){
  }
}
